	section .data		; ALL DATA STRUCTURES

	align 16
nti:	dd 0.0			; initial direction
nxi:	dd 0.6
nyi:	dd 0.0
nzi:	dd 0.8

rti:	dd 0.0			; initial position
rxi:	dd 0.0
ryi:	dd 0.0
rzi:	dd 0.0

nt:	dd 0.0			; current direction
nx:	dd 1.0
ny:	dd 0.0
nz:	dd 0.0

rt:	dd 0.0			; current position
rx:	dd 0.0
ry:	dd 0.0
rz:	dd 0.0

xrd:	dd 1.0			; 1+[0<random<1]
mtp:	dd 2083801278		; multiplier
rnd:	dd 362436069		; next random number
cry:	dd 1234567		; carry

xcos:	dd 0.8			; azimuthal rotation
xsin:	dd 0.6
zcos:	dd 0.8			; zenith inclination
zsin:	dd 0.6

cc:	dd 0.0
bc:	dd 0.0
sca:	dd 0.0
g:	dd 0.8

xx:	dd 1.e-5
cfpi:	dd 0.017453292		; pi/180
engy:	dd 1.e3			; particle energy
type:	dd 100.			; particle length/type

fdom:	db 20			; flasher definition
fstr:	db 63
fone:	dw 0x3f80
frms:	dd 0.278116		; 9.2*sqrt(3)*pi/180
fnum:	dd 1000000
fxtr:	dd 0			; high dword for long long

tmp:	dq 0.0			; temporary
c05:	dd 0.5
prc:	dw 127
	dw 0

line:	times 512 db 0
name:	times 32 db 0

outh:	db "HIT %d %d %g %g",10,0
diag:	db "Loaded: %d OMs, %d ice layers, %d wavelength points",\
	10,"Flasher: %s [str] [om] [num] [seed]; F2k: %s [seed]",10,0

inpt:	db "TR %d %d %31s %f %f %f %f %f %f %f %f",0
linf:	db " %511[^",10,"]%*1[",10,"]",0
outf:	db "%s",10,0

amup:	db "amu+",0
amum:	db "amu-",0
amun:	db "amu",0

delta:	db "delta",0
brems:	db "brems",0
epair:	db "epair",0

ep:	db "ep",0
em:	db "em",0
en:	db "en",0

munu:	db "munu",0
hadr:	db "hadr",0

	struc om
dom:	resb 1
stn:	resb 1
one:	resw 1
omx:	resd 1
omy:	resd 1
omz:	resd 1
	endstruc

%include "geo.asm"
%include "ice.asm"
%include "rnd.asm"
;%include "exa.asm"
