#!/bin/awk -f

BEGIN{
  xmin=-525;
  xmax=675;
  xnum=10;
  xstp=(xmax-xmin)/xnum;

  ymin=-600;
  ymax=600;
  ynum=10;
  ystp=(ymax-ymin)/ynum;

  zmin=-600;
  zmax=600;
  znum=20;
  zstp=(zmax-zmin)/znum;

  num=0;

  printf "\talign 16\n" > "geo.asm";
  printf "geo:\n" > "geo.asm";
  while(0 < getline < "geo-f2k") if($6>0 && $7<=60){
    x=$3; y=$4; z=$5+1948.07;

    printf "\tistruc om\n" > "geo.asm";
    printf "at dom,\tdb %d\n", $7 > "geo.asm";
    printf "at stn,\tdb %d\n", $6 > "geo.asm";
    printf "at one,\tdw 0x3f80\n" > "geo.asm";
    printf "at omx,\tdd %7.2f\n", x > "geo.asm";
    printf "at omy,\tdd %7.2f\n", y > "geo.asm";
    printf "at omz,\tdd %7.2f\n", z > "geo.asm";
    printf "\tiend\n" > "geo.asm";

    s=int((x-xmin)/xstp)"_"int((y-ymin)/ystp)"_"int((z-zmin)/zstp);
    ax[s","(an[s]+0)]=num;
    an[s]++;
    num++;
  }
  printf "lgeo:\tequ $-geo\n" > "geo.asm";

  printf "\n\talign 16\n" > "geo.asm";
  xmin+=xstp/2; xmax-=xstp/2; xrst=1/xstp;
  ymin+=ystp/2; ymax-=ystp/2; yrst=1/ystp;
  zmin+=zstp/2; zmax-=zstp/2; zrst=1/zstp;

  printf "rmin:\tdd %7.2f\n", 0 > "geo.asm";
  printf "xmin:\tdd %7.2f\n", xmin > "geo.asm";
  printf "ymin:\tdd %7.2f\n", ymin > "geo.asm";
  printf "zmin:\tdd %7.2f\n", zmin > "geo.asm";

  printf "rrst:\tdd %0.18f\n", 0 > "geo.asm";
  printf "xrst:\tdd %0.18f\n", xrst > "geo.asm";
  printf "yrst:\tdd %0.18f\n", yrst > "geo.asm";
  printf "zrst:\tdd %0.18f\n", zrst > "geo.asm";

  printf "pmin:\tdd %4.1f\n", 0 > "geo.asm";
  printf "\tdd %4.1f\n", 0 > "geo.asm";
  printf "\tdd %4.1f\n", 0 > "geo.asm";
  printf "\tdd %4.1f\n", 0 > "geo.asm";

  printf "pmax:\tdd %4.1f\n", 0 > "geo.asm";
  printf "\tdd %4.1f\n", xnum-1 > "geo.asm";
  printf "\tdd %4.1f\n", ynum-1 > "geo.asm";
  printf "\tdd %4.1f\n", znum-1 > "geo.asm";

  printf "qmin:\tdd %4.1f\n", 0 > "geo.asm";
  printf "\tdd %4.1f\n", -1 > "geo.asm";
  printf "\tdd %4.1f\n", -1 > "geo.asm";
  printf "\tdd %4.1f\n", -1 > "geo.asm";

  printf "qmax:\tdd %4.1f\n", 0 > "geo.asm";
  printf "\tdd %4.1f\n", xnum > "geo.asm";
  printf "\tdd %4.1f\n", ynum > "geo.asm";
  printf "\tdd %4.1f\n", znum > "geo.asm";

  printf "xnum:\tequ %d\n", ynum*znum > "geo.asm";
  printf "ynum:\tequ %d\n", znum > "geo.asm";

  printf "\n\talign 16\n" > "geo.asm";
  printf "els:\n" > "geo.asm";
  for(i=0; i<xnum; i++) for(j=0; j<ynum; j++) for(k=0; k<znum; k++){
    s=i"_"j"_"k;
    printf "el_%s:\tequ $-els\n", s > "geo.asm";
    for(n=0; n<an[s]; n++) printf "\t\tdw %d\n", ax[s","n]+0 > "geo.asm";
    printf "\t\tdw -1\n" > "geo.asm";
  }

  printf "\n\talign 16\n" > "geo.asm";
  printf "arr:\n" > "geo.asm";
  for(i=0; i<xnum; i++) for(j=0; j<ynum; j++) for(k=0; k<znum; k++) printf "\tdw el_%d_%d_%d\n", i, j, k > "geo.asm";

  printf "\n\talign 16\n" > "geo.asm";

  printf "sminr:\tdd %4.1f\n", 0 > "geo.asm";
  printf "sminx:\tdd %4.1f\n", 0 > "geo.asm";
  printf "sminy:\tdd %4.1f\n", 0 > "geo.asm";
  printf "sminz:\tdd %4.1f\n", 0 > "geo.asm";

  printf "smaxr:\tdd %4.1f\n", 0 > "geo.asm";
  printf "smaxx:\tdd %4.1f\n", xnum-1 > "geo.asm";
  printf "smaxy:\tdd %4.1f\n", ynum-1 > "geo.asm";
  printf "smaxz:\tdd %4.1f\n", znum-1 > "geo.asm";

  printf "\n" > "geo.asm";
}
