#!/bin/awk -f

BEGIN{
  c=0.299792458;
  wnum=40; wfla=405;

  printf "\talign 16\n" > "ice.asm";

  k=0; while(0 < getline < "wv.dat") if(NF==2){ pw[k]=$1; wv[k]=$2; k++; }
  if(k<2) exit 1;

  for(i=0; i<wnum; i++){
    wp=(i+0.5)/wnum;
    j=0; while(pw[++j]<wp);
    w=(wv[j-1]*(pw[j]-wp)+wv[j]*(wp-pw[j-1]))/(pw[j]-pw[j-1]);

    faux=w-wfla; if(faux<0) faux=-faux;
    if(i==0 || faux<fmin){ nfla=i; fmin=faux; }

    run="./ppc -"(w*1.e-3)" 2>&1 | sed 's-.*np=--; s-ng=--'";
    n=0; while(run | getline){
      if(NF==2){ np=$1; ng=$2; }
      else if(NF==3){ z[n]=1948.07-$1; a[n]=$2; s[n]=$3; n++; }
    }
    if(n<2) exit 1;

    wocm=ng/c;
    wcos=1/np;
    wsin=sqrt(1-wcos^2);

    if(i==0) printf "wvln:" > "ice.asm"; printf "\tdd %g\n", w > "ice.asm";
    if(i==0) printf "wocm:" > "ice.asm"; printf "\tdd %g\n", wocm > "ice.asm";
    if(i==0) printf "wcos:" > "ice.asm"; printf "\tdd %g\n", wcos > "ice.asm";
    if(i==0) printf "wsin:" > "ice.asm"; printf "\tdd %g\n", wsin > "ice.asm";

    for(j=0; j<n; j++){
      if(i==0 && j==0) printf "csca:" > "ice.asm"; printf "\tdd %g\n", s[n-1-j] > "ice.asm";
      if(i==0 && j==0) printf "cabs:" > "ice.asm"; printf "\tdd %g\n", a[n-1-j] > "ice.asm";
    }

    if(i==0) printf "eice:\tequ $-wvln\n" > "ice.asm";
    printf "\n" > "ice.asm";
  }

  dz=z[0]-z[1];
  printf "lnum:\tequ %d\n", n-1 > "ice.asm";
  printf "lstp:\tdd %4.1f\n", dz > "ice.asm";
  printf "lhst:\tdd %4.1f\n", dz/2 > "ice.asm";
  printf "lrst:\tdd %4.1f\n", 1/dz > "ice.asm";
  printf "lmin:\tdd %g\n", z[n-1] > "ice.asm";
  printf "\n" > "ice.asm";

  printf "wnum:\tdd %d\n", wnum > "ice.asm";
  printf "loff:\tdd %d\n", nfla > "ice.asm";

  ovr=5.0;
  rho=0.9216;
  omr=0.16510*ovr;
  ppm=2450.08/ovr^2;
  printf "omr:\tdd %g\n", omr > "ice.asm";
  printf "vocm:\tdd %0.8f\n", 1/c > "ice.asm";
  printf "\n" > "ice.asm";
  printf "crf0:\tdd %g\n", ppm*4.889*0.894/rho > "ice.asm";
  printf "crf1:\tdd %g\n", ppm*4.076*0.860/rho > "ice.asm";
  printf "crf2:\tdd %g\n", ppm*1.1720 > "ice.asm";
  printf "crf3:\tdd %g\n", ppm*0.0324 > "ice.asm";
  printf "\n" > "ice.asm";
}
