	section	.text

track:				; -- track -->
	fld dword [type]
	fldz
	fcomip st1
	jb muo1
	fstp st0

	mov ecx,[type]
	jecxz cas1
	fld dword [crf1]
	jmp cas2
cas1:	fld dword [crf0]
cas2:	fmul dword [engy]
	fistp qword [fnum]	; needs long long

	mov edx,[fxtr]
	mov eax,[fnum]
	mov ecx,eax
	or ecx,edx
	jecxz cas4

cas3:	movaps xmm0,[nti]
	movaps xmm1,[rti]

	push edx
	push eax
	call cscd
	pop eax
	pop edx

	sub eax,1
	sbb edx,0
	cmp eax,0
	jnz cas3
	cmp edx,0
	jnz cas3

cas4:	jmp cont

muo1:	fldln2
	fld dword [engy]
	fyl2x
	fmul dword [crf3]
	fadd dword [crf2]
	fmulp st1
	fistp dword [fnum]

	mov ecx,[fnum]
	jecxz cont

	xor eax,eax
muo2:	mov [sca],eax
	fild dword [sca]
	fmul dword [type]
	fidiv dword [fnum]
	fstp dword [sca]

	movaps xmm0,[nti]
	movaps xmm1,[rti]

	movaps xmm4,xmm0	; -- advance --
	addss xmm4,[vocm]	; 1/cv-n vector
	movss xmm3,[sca]
	shufps xmm3,xmm3,0x00
	mulps xmm4,xmm3
	addps xmm1,xmm4		; current position

	push eax
	push ecx
	call cscd
	pop ecx
	pop eax

	inc eax
	cmp eax,ecx
	jl muo2

cont:	ret			; <-- track --


cscd:	call rand		; -- cascade -->
	fimul dword [wnum]
	fsub dword [c05]
	fistp dword [loff]
	imul ebp,[loff],eice	; offset for the given wavelength
	mov [loff],ebp

	movss xmm5,[ebp+wocm]	; 1/cm-0 vector
	movlps xmm2,[ebp+wcos]
	movlps [zcos],xmm2
	call rotate
	call prop

	cmp ebx,0
	jz csc1
	call printh
csc1:	ret			; <-- cascade --


flsh:				; -- flasher -->
	mov ebx,[fdom]
	mov ecx,lgeo
fls1:	lea eax,[geo-om_size+ecx]
	cmp ebx,[eax]
	jz fls2
	sub ecx,om_size
	jnz fls1
	jmp fls3
fls2:	movaps xmm1,[eax]
	subss xmm1,xmm1
	movaps [rti],xmm1
fls3:
	imul ebp,[loff],eice	; offset for the given wavelength
	mov [loff],ebp
	movss xmm5,[ebp+wocm]	; 1/cm-0 vector

	mov ecx,[fnum]
nxt1:	push ecx

	call rand
	fadd st0
	fld1
	fsubp st1
	fmul dword [frms]
	fsincos
	call rand
	fldpi
	fadd st0
	fmulp st1
	fsincos
	fmul st2
	fstp dword [nxi]
	fmulp st1
	fstp dword [nyi]
	fstp dword [nzi]

	movaps xmm0,[nti]
	movaps xmm1,[rti]

	call prop

	cmp ebx,0
	jz nxt2
	call printh

nxt2:	pop ecx
	dec ecx
	jnz nxt1
	ret			; <-- flasher -- 


init:	fldcw [prc]		; MAIN INITIALIZATION
	xor edx,edx
	mov eax,[sca]
	cmp eax,0
	jz fin
	dec eax
	mov ecx,ernd
	shr ecx,2
	div ecx
	mov eax,[brnd+edx*4]
	mov [mtp],eax
	call rand
	fstp st0
fin:	ret			; <-- init --


rand:	mov eax,[rnd]		; RANDOM NUMBER GENERATOR
	mul dword [mtp]
	add eax,[cry]
	adc edx,0
	mov [cry],edx
	mov [rnd],eax
	shr eax,9
	cmp eax,0
	jz rand
	or eax,0x3f800000	; or 1.0
	mov [xrd],eax
	fld dword [xrd]
	fld1
	fsubp st1
	ret			; <-- rand --


printh:	movaps xmm7,xmm0	; PRINT HIT INFO
	shufps xmm7,xmm7,0x93
	movss [tmp],xmm7
	fld dword [tmp]
	fstp qword [tmp]
	push dword [tmp+4]
	push dword [tmp]

	movss [tmp],xmm1
	fld dword [tmp]
	fstp qword [tmp]
	push dword [tmp+4]
	push dword [tmp]

	mov eax,ebx
	and eax,0xff
	push eax
	shr ebx,8
	and ebx,0xff
	push ebx

	push dword outh
	call printf
	add esp,28
	ret			; <-- printh --

