rotxrd:				; MAIN ROTATION
	fld dword [g]		; g
	call rand
	fadd st0		; 2*xi
	fld1
	fsubp st1		; xi=1-2*xi
	fldz
	fcomip st2
	jz rot1
	fmul st1		; g*xi
	fld1
	faddp st1		; 1+g*xi
	fld st1
	fmul st0		; g^2
	fld1
	fsub st1		; 1-g^2
	fdiv st2		; ga=(1-g^2)/(1+g*xi)
	fmul st0		; ga^2
	fld1
	faddp st2		; 1+g^2
	fsubp st1		; 1+g^2-ga^2
	fld st2
	faddp st3		; 2*g
	fdivrp st2		; (1+g^2-ga^2)/(2*g)
	fstp st0
rot1:	fld1
	fchs
	fxch st1
	fcomi st1		; compare with -1
	fcmovb st1
	fxch st1
	fchs
	fxch st1
	fcomi st1		; compare with +1
	fcmovnbe st1
	fxch st1
	fld st1
	fmul st0
	fsubp st1
	fsqrt			; sqrt(1-cos^2)
	fstp dword [zsin]
	fstp dword [zcos]	; <-- rotxrd --


rotate:	call rand		; AUXILIARY ROTATION

	movaps xmm7,xmm0
	mulps xmm7,xmm7		; n^2
	movaps xmm2,xmm7
	shufps xmm2,xmm2,0xe5	; zyxx x
	movaps xmm3,xmm7
	shufps xmm3,xmm3,0xe6	; zyxy y
	movaps xmm4,xmm7
	shufps xmm4,xmm4,0xe7	; zyxz z
	comiss xmm2,xmm3
	jc jl1			; if x<y
	comiss xmm2,xmm4
	jc near cm2		; if x<z
	jmp cm0
jl1:	comiss xmm3,xmm4
	jc near cm2		; if y<z
	jmp cm1

cm0:	movaps xmm7,xmm2
	shufps xmm7,xmm7,0x4e	; xxzy
	addps xmm7,xmm2
	rsqrtps xmm7,xmm7
	movaps xmm3,xmm0	; <-->
	shufps xmm3,xmm3,0x10	; 0x00
	movaps xmm4,xmm0
	shufps xmm4,xmm4,0x08	; 00y0
	subps xmm3,xmm4		; 0xY0
	movaps xmm6,xmm7
	shufps xmm6,xmm6,0x00	; x+y
	mulps xmm6,xmm3		; p1
	movaps xmm3,xmm0	; <-->
	shufps xmm3,xmm3,0x40	; x000
	movaps xmm4,xmm0
	shufps xmm4,xmm4,0x0c	; 00z0
	subps xmm3,xmm4		; x0Z0
	shufps xmm7,xmm7,0x55	; x+z
	mulps xmm7,xmm3		; p2
	jmp jl2

cm1:	movaps xmm7,xmm3
	shufps xmm7,xmm7,0x1b	; yxyz
	addps xmm7,xmm3
	rsqrtps xmm7,xmm7
	movaps xmm4,xmm0	; <-->
	shufps xmm4,xmm4,0x80	; y000
	movaps xmm2,xmm0
	shufps xmm2,xmm2,0x30	; 0z00
	subps xmm4,xmm2		; yZ00
	movaps xmm6,xmm7
	shufps xmm6,xmm6,0x00	; x+z
	mulps xmm6,xmm4		; p1
	movaps xmm4,xmm0	; <-->
	shufps xmm4,xmm4,0x08	; 00y0
	movaps xmm2,xmm0
	shufps xmm2,xmm2,0x10	; 0x00
	subps xmm4,xmm2		; 0Xy0
	shufps xmm7,xmm7,0x55	; x+y
	mulps xmm7,xmm4		; p2
	jmp jl2

cm2:	movaps xmm7,xmm4
	shufps xmm7,xmm7,0x4e	; xzzy
	addps xmm7,xmm4
	rsqrtps xmm7,xmm7
	movaps xmm2,xmm0	; <-->
	shufps xmm2,xmm2,0x0c	; 00z0
	movaps xmm3,xmm0
	shufps xmm3,xmm3,0x40	; x000
	subps xmm2,xmm3		; X0z0
	movaps xmm6,xmm7
	shufps xmm6,xmm6,0x55	; x+z
	mulps xmm6,xmm2		; p1
	movaps xmm2,xmm0	; <-->
	shufps xmm2,xmm2,0x30	; 0z00
	movaps xmm3,xmm0
	shufps xmm3,xmm3,0x80	; y000
	subps xmm2,xmm3		; Yz00
	shufps xmm7,xmm7,0x00	; y+z
	mulps xmm7,xmm2		; p2

jl2:	movaps xmm3,xmm6
	subps xmm3,xmm7		; p1-p2
	addps xmm7,xmm6		; p1+p2
	movaps xmm4,xmm3
	mulps xmm4,xmm4		; (p1-p2)^2
	movaps xmm6,xmm7
	mulps xmm6,xmm6		; (p1+p2)^2
	movaps xmm2,xmm4
	shufps xmm2,xmm6,0x11	; 0101
	shufps xmm4,xmm6,0xee	; 3232
	addps xmm4,xmm2		; z x+y z x+y
	movaps xmm2,xmm4
	shufps xmm2,xmm2,0xb1
	addps xmm4,xmm2		; x+y+z
	rsqrtps xmm4,xmm4
	movaps xmm6,xmm4
	shufps xmm4,xmm4,0x00	; 0000
	shufps xmm6,xmm6,0xaa	; 2222
	mulps xmm3,xmm4		; a1
	mulps xmm7,xmm6		; a2

	fldpi
	fadd st0		; 2*pi
	fmulp st1
	fsincos
	fstp dword [xcos]
	fstp dword [xsin]

	movlps xmm4,[xcos]
	movaps xmm6,xmm4
	shufps xmm6,xmm6,0x00	; cos
	shufps xmm4,xmm4,0x55	; sin
	mulps xmm6,xmm3
	mulps xmm4,xmm7
	addps xmm4,xmm6		; u

	movlps xmm2,[zcos]
	movaps xmm3,xmm2
	shufps xmm3,xmm3,0x00	; cos
	shufps xmm2,xmm2,0x55	; sin
	mulps xmm4,xmm2
	mulps xmm0,xmm3
	addps xmm0,xmm4		; new n
	movaps xmm7,xmm0
	mulps xmm7,xmm7
	shufps xmm7,xmm7,0x39	; rotate
	movss xmm2,xmm7
	shufps xmm7,xmm7,0x39	; rotate
	movss xmm3,xmm7
	shufps xmm7,xmm7,0x39	; rotate
	movss xmm4,xmm7
	addss xmm2,xmm3
	addss xmm2,xmm4
	rsqrtss xmm2,xmm2
	shufps xmm2,xmm2,0x00
	mulps xmm0,xmm2		; new n
jl3:	ret			; <-- rotate --

